"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.addForwardPolyAssociation = void 0;
const utils_1 = require("./utils");
exports.addForwardPolyAssociation = (builder, option) => {
    builder.hook('inflection', inflection => (Object.assign(Object.assign({}, inflection), { forwardRelationByPolymorphic(table, polymorphicName) {
            return this.camelCase(`${this.singularize(table.name)}-as-${polymorphicName}`);
        } })));
    builder.hook('GraphQLObjectType:fields', (fields, build, context) => {
        const { extend, inflection, pgPolymorphicClassAndTargetModels, } = build;
        const { scope: { isPgRowType, pgIntrospection: table }, fieldWithHooks, } = context;
        if (!isPgRowType || !table || table.kind !== 'class') {
            return fields;
        }
        utils_1.validatePrerequisit(build);
        const forwardPolyRelationSpec = pgPolymorphicClassAndTargetModels
            .filter(con => con.from.id === table.id)
            .reduce((memo, currentPoly) => {
            const { name } = currentPoly;
            const fieldsPerPolymorphicConstraint = currentPoly.to.reduce((acc, polyC) => {
                const { pgClass: foreignTable, name: mName, pKey: foreignPrimaryKey } = polyC;
                const fieldName = `${inflection.forwardRelationByPolymorphic(foreignTable, name)}`;
                const fieldFunction = utils_1.generateFieldWithHookFunc(build, foreignTable, (qb1, qb2) => {
                    qb2.where(utils_1.polymorphicCondition(build, currentPoly, qb1, qb2, mName, foreignPrimaryKey));
                });
                return Object.assign(Object.assign({}, acc), { [fieldName]: fieldWithHooks(fieldName, fieldFunction, {
                        isPgForwardPolymorphicField: true,
                        pgFieldIntrospection: foreignTable,
                    }) });
            }, {});
            return extend(memo, fieldsPerPolymorphicConstraint);
        }, {});
        return extend(fields, forwardPolyRelationSpec);
    });
};
//# sourceMappingURL=add_forward_poly_association_plugin.js.map