import { GraphileBuild, PgPolymorphicConstraint } from './postgraphile_types';
import { QueryBuilder, PgClass, PgAttribute } from 'graphile-build-pg';
import { IGraphQLToolsResolveInfo } from 'graphql-tools';
import { Build } from 'postgraphile';
export declare function canonical(str: string): string;
export declare const validatePrerequisit: (build: GraphileBuild) => void;
export declare const getSourceColumns: (c: PgPolymorphicConstraint) => {
    sourceTableId: string;
    sourceTableType: string;
};
export declare const isPolymorphicColumn: (attr: PgAttribute) => boolean;
export declare const columnToPolyConstraint: (build: GraphileBuild, attr: PgAttribute) => PgPolymorphicConstraint;
export declare const generateFieldWithHookFunc: (build: GraphileBuild, innerTable: PgClass, joinCallback: (qb1: QueryBuilder, qb2: QueryBuilder) => void, isUnique?: boolean, isConnection?: boolean) => ({ getDataFromParsedResolveInfoFragment, addDataGenerator }: any) => {
    description: string;
    type: any;
    args: {};
    resolve: (data: any, _args: any, _context: any, resolveInfo: IGraphQLToolsResolveInfo) => any;
};
export declare const getPrimaryKeys: (table: PgClass) => PgAttribute[];
export declare const getPrimaryKey: (table: PgClass) => PgAttribute;
export declare const polyForeignKeyUnique: (build: GraphileBuild, foreignTable: PgClass, c: PgPolymorphicConstraint) => boolean;
export declare const polySqlKeyMatch: (build: Build, polyAlias: any, foreignAlias: any, fPKey: PgAttribute, modelName: string, polyConstraint: PgPolymorphicConstraint) => any;
export declare const polymorphicCondition: (build: Build, c: PgPolymorphicConstraint, polyQueryBuilder: QueryBuilder, targetQueryBuilder: QueryBuilder, targetModelName: string, pKey: PgAttribute) => any;
export declare const ensureBuilderUniqueOrder: (build: Build, innerBuilder: QueryBuilder, table: PgClass) => void;
